/// <reference types="node" />
import type { Provider } from '@nestjs/common';
import { AsyncLocalStorage } from 'async_hooks';
import { AsyncLocalStorageModuleOptions, ContextStore } from './async-local-storage.interfaces';
import { AsyncLocalStorageService } from './async-local-storage.service';
export declare function createAsyncLocalStorageProviders(options: AsyncLocalStorageModuleOptions): [
    Provider<AsyncLocalStorage<ContextStore>>,
    Provider<AsyncLocalStorageModuleOptions>,
    Provider<AsyncLocalStorageService>
];
