/// <reference types="node" />
import { AsyncLocalStorage } from 'async_hooks';
import { ContextStore, RequestContext } from './async-local-storage.interfaces';
export declare class AsyncLocalStorageService {
    readonly instance: AsyncLocalStorage<ContextStore>;
    private static _instance;
    constructor(instance: AsyncLocalStorage<ContextStore>);
    static get instance(): AsyncLocalStorage<ContextStore>;
    static set instance(value: AsyncLocalStorage<ContextStore>);
    static get store(): ContextStore;
    static get requestContext(): RequestContext;
    static set requestContext(value: RequestContext);
    static enterWith(value?: ContextStore): void;
    static enter(): void;
    static exit(cb?: () => void): void;
    get store(): ContextStore;
    get requestContext(): RequestContext;
    set requestContext(value: RequestContext);
    enterWith(value?: ContextStore): void;
    enter(): void;
    exit(cb?: () => void): void;
}
